/* *****************************************************************************
 *  Name:    Alan Turing
 *  NetID:   aturing
 *  Precept: P00
 *
 *  Partner Name:    Ada Lovelace
 *  Partner NetID:   alovelace
 *  Partner Precept: P00
 *
 *  Description:  An Account has basic functions like adding and
 *                withdrawing funds and checking the current balance.
 *
 **************************************************************************** */

import edu.princeton.cs.algs4.StdOut;

public class Account {
    private int balance; // amount of money in account

    // initializing account with 0 funds
    public Account() {
        balance = 0;
    }

    // initializing account with non-negative amount
    public Account(int amount) {
        if (amount < 0) {
            throw new IllegalArgumentException("cannot have negative balance");
        }
        balance = amount;
    }

    // deposit amount to account
    public void deposit(int amount) {
        balance += amount;
    }

    // withdraw funds if available
    public void withdraw(int amount) {
        if (balance > 0) {
            balance -= amount;
        }
    }

    // check current balance
    public int checkBalance() {
        return balance;
    }

    // string representation of this account
    public String toString() {
        return String.format("[ bal: %d ]", balance);
    }

    public static void main(String[] args) {
        Account a = new Account();
        a.deposit(50);
        StdOut.println("expect 50: " + a.checkBalance());
        a.withdraw(10);
        StdOut.println("expect 40: " + a.checkBalance());
    }
}
