public class BuggyLinkedList<Item> {

    public class Node {
        private final Item item;
        private Node next;

        public Node(Item item) {
            this.item = item;
            this.next = null;
        }
    }

    // the head of the linked list
    private Node head;

    public void addFront(Item item) {
        Node n = new Node(item);
        n.next = head;
        head = n;
    }

    public void addBack(Item item) {
        Node n = new Node(item);

        Node current = head;
        while (current.next != null) {
            current = current.next;
        }
        current.next = n;
    }

    public Item removeFront() {
        if (head != null) {
            Item i = head.item;
            head = head.next;
            return i;
        }
        return null;
    }

    public void removeBack() {
        Node current = head;

        while (current.next != null) {
            current = current.next;
        }
        current.next = null;
    }

    public String toString() {
        StringBuilder s = new StringBuilder();
        Node current = head;
        while (current != null) {
            s.append(current.item.toString() + " -> ");
            current = current.next;
        }
        s.append("null");
        return s.toString();
    }

    public static void main(String[] args) {
        BuggyLinkedList<String> x = new BuggyLinkedList<String>();

        // TODO: Find the 2 bugs in this code and fix them!
        // Write tests and use the debugger.
    }
}
